var currentTabPane;
var settingsUI = function () {
    var items = [
        [
            {el: {type: 'llabel', value: FR.i18nText('Plugin-Expiration_Setting')}},
            {
                el: {
                    type: 'radiogroup', items: [
                        {text: FR.i18nText('Plugin-Expiration_One_Month'), value: '1'},
                        {text: FR.i18nText('Plugin-Expiration_Three_Month'), value: '3'},
                        {text: FR.i18nText('Plugin-Expiration_Six_Month'), value: '6'},
                        {text: FR.i18nText('Plugin-Expiration_One_Year'), value: '12'}]
                    , widgetName: 'value'
                }
            }
        ],
        [
            {el: {type: 'llabel', value: ''}},
            {el: $('<div>').text(FR.i18nText('Plugin-Expiration_Attention'))}
        ],
        [
            {el: {type:'llabel', value: FR.i18nText('Plugin-Expiration_Warning_Value') + ':'}},
            {el: {type:'number', value:6, widgetName: 'warningCount', allowDecimals:false,allowNegative:false}}
        ]
    ];
    var basicTablelayout = {
        widgetName: 'pw_tablelayout',
        type: 'tablelayout',
        items: items,
        columnSize: [131, 450],
        rowSize: [21, 21, 21],
        vgap: 20
    };
    return {
        title: FR.i18nText('Plugin-Expiration_Title'),
        content: {
            widgetName: 'pw_setting_pane',
            type: 'confirm',
            firstBtnMargin: 0,
            text4OK: FR.i18nText("FS-Frame-Simple_Save"),
            text4Cancel: null,
            width: 650,
            height: 200,
            btnsAlignment: 'left',
            closeAfterAction: false,
            doSize: true,
            onOK: function () {
                save();
            },
            contentWidget: basicTablelayout
        }
    };
};
var save = function () {
    var value = currentTabPane.getWidgetByName('value').getValue();
    var warningCount = currentTabPane.getWidgetByName('warningCount').getValue();
    FR.ajax({
        url: FR.servletURL + '?op=expiration&cmd=update',
        data: {
            'value': value,
            'warningCount' : warningCount
        },
        complete: function (res, status) {
            var data = FR.jsonDecode(res.responseText);
            if (data.status == 'success') {
                FR.Msg.toast("Save Successfully!");
            } else {
                FR.Msg.alert("Error", data.message);
            }
        }
    });
};
FS.Plugin.SystemItems.push({

    ui: settingsUI,

    pop: function (idx, tabPane) {
        currentTabPane = tabPane;
        FR.ajax({
            url: FR.servletURL + '?op=expiration&cmd=populate',
            complete: function (res, status) {
                var r = FR.jsonDecode(res.responseText);
                tabPane.getWidgetByName("value").setValue(r.value);
                tabPane.getWidgetByName("warningCount").setValue(r.warningCount);
            }
        });
    }
});