;(function ($) {
    if (!FR.Expiration) {
        FR.Expiration = {};
    }
    $.extend(FR.Expiration, {
        
        check : function (username, password, url) {
            FR.ajax({
                url : FR.servletURL + '?op=expiration&cmd=check',
                data : {
                    username : username
                },
                complete : function (res) {
                    var data = FR.jsonDecode(res.responseText);
                    if (data.status == 'success') {
                        if (data.remainDays) {
                            if (data.remainDays < 0) {
                                FR.Expiration.showPwdModifyDialog(url);
                            } else {
                                FR.Msg.confirm(
                                    FR.i18nText('Plugin-Expiration_Title'),
                                    FR.i18nText('Plugin-Expiration_Warning_Days', data.remainDays),
                                    function (result) {
                                        if (result) {
                                            FR.Expiration.showPwdModifyDialog(url);
                                        } else {
                                            window.location.href = url;
                                        }
                                    }
                                );
                            }
                        } else {
                            window.location.href = url;
                        }
                    }
                }
            });
        },
        showPwdModifyDialog : function (url) {
            var save = function () {
                var oldPassword = content.getWidgetByName('oldPwdText').getValue();
                var newPassword = content.getWidgetByName('newPwdText').getValue();
                var verifyPassword = content.getWidgetByName('verifyPwdText').getValue();
                if (oldPassword == newPassword) {
                    FR.Msg.alert(FR.i18nText('Plugin-Expiration_Warning'), FR.i18nText('Plugin-Password_Not_Same'));
                    return;
                }
                if (newPassword != verifyPassword) {
                    FR.Msg.toast(FR.i18nText('Plugin-Expiration_Warning'), FR.i18nText('Plugin-Password_Sure_Same'));
                    return;
                }
                FR.ajax({
                    url : FR.servletURL + '?op=fs_main&cmd=user_changepw',
                    data : {
                        oldp : oldPassword,
                        np : newPassword
                    },
                    complete : function (res) {
                        var data = FR.jsonDecode(res.responseText);
                        if (data.success) {
                            FR.Msg.alert(FR.i18nText('Plugin-Expiration_Warning'), FR.i18nText('Plugin-Password_Modify_Success'), function () {
                                window.location.href = url;
                            });
                        } else {
                            FR.Msg.alert(FR.i18nText('Plugin-Expiration_Warning'), FR.i18nText('Plugin-Password_Modify_Failed'));
                        }
                    }
                });
            };
            var cfgItems = [
                [   null,
                    {el: {type: 'llabel', value: FR.i18nText("FS-Admin-Old_Password")}},
                    {el: {type: 'password', widgetName: 'oldPwdText'}}
                ],
                [
                    null,
                    {el: {type: 'llabel', value: FR.i18nText("FS-Admin-Enter_New_Password")}},
                    {el: {type: 'password', widgetName: 'newPwdText'}}
                ],
                [
                    null,
                    {el: {type: 'llabel', value: FR.i18nText("FS-Admin-Verify_New_Password")}},
                    {el: {type: 'password', widgetName: 'verifyPwdText'}}
                ],
                [
                    null,
                    null,
                    {el: {type: 'quickbutton', text : FR.i18nText('Plugin-Expiration_Save'), handler : save}}
                ]
            ];
            var content = FR.createWidget({
                type : 'border',
                items : [
                    {region : 'north', height : 20, el : $('<div>')},
                    {region : 'center', el : {
                        type: 'tablelayout',
                        widgetName: 'userPwdTablelayout',
                        columnSize: [40, 100, 132],
                        rowSize: [21, 21, 21, 24],
                        vgap: 19,
                        items: cfgItems
                    }}
                ]
            });
            FR.showDialog({
                title : FR.i18nText('Plugin-Password_Setting'),
                width: 405,
                height: 250,
                contentWidget : content
            });
        }
    });
})(jQuery);